.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include	 \masm32\include\gdi32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib

include	   lib\pnglib.inc
includelib lib\pnglib.lib

; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc  PROTO : HWND, : UINT, : WPARAM, : LPARAM
LoadPng	    PROTO : DWORD,: DWORD
VertFlip    PROTO :HBITMAP
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_FRAME     equ 300
; Required data

.data
szTitle    db "Flip Image Vertically In Memory After Loading It", 0


.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hBrush		dd	?
hWND		dd	?
hIMG		dd	?
sizeFrame	dd	?,?
rect    RECT	<>
.code

start:
invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
invoke ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT

 .if uMsg == WM_INITDIALOG
 
invoke SetWindowText, hWnd, addr szTitle 
invoke SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon

invoke LoadPng,300,addr sizeFrame
mov hIMG,eax
invoke VertFlip,hIMG
invoke CreatePatternBrush,hIMG
mov hBrush,eax


.elseif uMsg == WM_CTLCOLORDLG
mov eax,hBrush
ret

.elseif uMsg == WM_PAINT
invoke BeginPaint,hWnd,addr ps
invoke EndPaint,hWnd,addr ps

.elseif uMsg == WM_COMMAND

.elseif uMsg == WM_CLOSE
invoke EndDialog, hWnd, 0
 .endif

    xor eax,eax
  ret
DialogProc endp
; Load Png procedure
; ************************************
LoadPng proc ID:DWORD,pSize:DWORD
local pngInfo:PNGINFO

invoke PNG_Init, addr pngInfo
invoke PNG_LoadResource, addr pngInfo, hInstance, ID
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_Decode, addr pngInfo
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_CreateBitmap, addr pngInfo, hWND, PNG_OUTF_AUTO, FALSE
.if	!eax
xor eax, eax
jmp @cleanup
.endif
mov edi,pSize
.if edi!=0
lea esi,pngInfo
movsd
movsd
.endif

@cleanup:
push eax	
invoke PNG_Cleanup, addr pngInfo

pop eax
ret

LoadPng endp
; VertFlip procedure
; ************************************
VertFlip PROC   hbmpInput:HBITMAP

;Creates a bitmap that is vertically flipped.
;If there is an error, EAX returns 0.
;Otherwise, DeleteObject should be used to delete the handle returned in EAX when done using it.
;
;-----------------------------------------

    LOCAL   bms        :BITMAP
    LOCAL   hdcDesktop :HDC
    LOCAL   hdcTemp1   :HDC
    LOCAL   hdcTemp2   :HDC
    LOCAL   hbmpPrev1  :HBITMAP
    LOCAL   hbmpOutput :HBITMAP
    LOCAL   hbmpPrev2  :HBITMAP

;-------------------------

    INVOKE  GetObject,hbmpInput,sizeof BITMAP,addr bms
    .if eax
        INVOKE  GetDC,HWND_DESKTOP
        mov     hdcDesktop,eax
        INVOKE  CreateCompatibleDC,eax
        mov     hdcTemp1,eax
        INVOKE  SelectObject,eax,hbmpInput
        mov     hbmpPrev1,eax
        INVOKE  CreateCompatibleDC,hdcDesktop
        mov     hdcTemp2,eax
        INVOKE  CreateCompatibleBitmap,hdcDesktop,bms.bmWidth,bms.bmHeight
        mov     hbmpOutput,eax
        INVOKE  SelectObject,hdcTemp2,eax
        mov     hbmpPrev2,eax
        mov     ecx,bms.bmHeight
        xor     edx,edx
        mov     eax,ecx
        neg     ecx
        dec     eax
        INVOKE  StretchBlt,hdcTemp2,edx,eax,bms.bmWidth,ecx,
                hdcTemp1,edx,edx,bms.bmWidth,bms.bmHeight,SRCCOPY
        INVOKE  SelectObject,hdcTemp2,hbmpPrev2
        INVOKE  DeleteDC,hdcTemp2
        INVOKE  SelectObject,hdcTemp1,hbmpPrev1
        INVOKE  DeleteDC,hdcTemp1
        INVOKE  ReleaseDC,HWND_DESKTOP,hdcDesktop
        mov     eax,hbmpOutput
    .endif
    ret

VertFlip ENDP

; ************************************
end start