.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include	 \masm32\include\gdi32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib

include	   lib\pnglib.inc
includelib lib\pnglib.lib
include		\masm32\macros\macros.asm
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc  PROTO : HWND, : UINT, : WPARAM, : LPARAM
LoadPng	    PROTO : DWORD,: DWORD
VFlipBmp    PROTO :HBITMAP
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_FRAME     equ 300
; Required data

.data
szTitle    db "Flip Image Vertically In Memory After Loading It", 0


.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hBrush		dd	?
hWND		dd	?
hIMG		dd	?
sizeFrame	dd	?,?
rect    RECT	<>
.code

start:
invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
invoke ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT

 .if uMsg == WM_INITDIALOG
 
invoke SetWindowText, hWnd, addr szTitle 
invoke SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon

invoke LoadPng,300,addr sizeFrame
mov hIMG,eax
invoke VFlipBmp,hIMG
invoke CreatePatternBrush,hIMG
mov hBrush,eax


.elseif uMsg == WM_CTLCOLORDLG
mov eax,hBrush
ret

.elseif uMsg == WM_PAINT
invoke BeginPaint,hWnd,addr ps
invoke EndPaint,hWnd,addr ps

.elseif uMsg == WM_COMMAND

.elseif uMsg == WM_CLOSE
invoke EndDialog, hWnd, 0
 .endif

    xor eax,eax
  ret
DialogProc endp
; Load Png procedure
; ************************************
LoadPng proc ID:DWORD,pSize:DWORD
local pngInfo:PNGINFO

invoke PNG_Init, addr pngInfo
invoke PNG_LoadResource, addr pngInfo, hInstance, ID
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_Decode, addr pngInfo
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_CreateBitmap, addr pngInfo, hWND, PNG_OUTF_AUTO, FALSE
.if	!eax
xor eax, eax
jmp @cleanup
.endif
mov edi,pSize
.if edi!=0
lea esi,pngInfo
movsd
movsd
.endif

@cleanup:
push eax	
invoke PNG_Cleanup, addr pngInfo

pop eax
ret

LoadPng endp
; VertFlip procedure
; ************************************
VFlipBmp proc uses esi hBitmap:HBITMAP
LOCAL bmp:BITMAP
LOCAL hMemDC1:HDC
LOCAL hBmp1:HBITMAP
LOCAL hMemDC2:HDC
LOCAL hBmp2:HBITMAP

.if rv(GetObject,hBitmap,SIZEOF bmp,ADDR bmp)
mov esi,rv(GetDC,rv(GetDesktopWindow))
mov hMemDC1,rv(CreateCompatibleDC,esi)
mov hBmp1,rv(SelectObject,hMemDC1,rv(CreateCompatibleBitmap,esi,bmp.bmWidth,bmp.bmHeight))
mov hMemDC2,rv(CreateCompatibleDC,esi)
mov hBmp2,rv(SelectObject,hMemDC2,hBitmap)
invoke ReleaseDC,rv(GetDesktopWindow),esi
mov edx,bmp.bmWidth
neg edx
invoke StretchBlt,hMemDC1,bmp.bmWidth,0,edx,bmp.bmHeight,hMemDC2,0,0,bmp.bmWidth,bmp.bmHeight,SRCCOPY

invoke BitBlt,hMemDC2,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC1,0,0,SRCCOPY

invoke DeleteObject,rv(SelectObject,hMemDC1,hBmp1)
invoke DeleteDC,hMemDC1
invoke SelectObject,hMemDC2,hBmp2
invoke DeleteDC,hMemDC2
.endif

ret

VFlipBmp endp

; ************************************
end start